//	Combat diver was created by The Chain of Command
//	This addon for Operation Flashpoint is shareware and can be distributed under the 
//	following conditions: 
//
//	If you want to use some or all of the content of this addon for your own work,
//	send a request to matthijs@myrealbox.com
//
//	- Non commercial distribution only
//	- Modified versions may never be packaged with the original versions
//	- Modified versions may never have the same class names the original versions
//	- Original packages may not be modified in any way
//
//	Model\Skinning\Importing by Willem-Matthijs Crielaard
//	V1.0R (Operation Flashpoint: Resistance)

//	The LAR VII rebreather was created by W.M. Crielaard (matthijs@myrealbox.com)
//	This addon for Operation Flashpoint is shareware and can be distributed under the 
//	following conditions: 
//
//	If you want to use some or all of the content of this addon for your own work,
//	send a request to webmaster@bbemariniers.net
//
//	- Non commercial distribution only
//	- Modified versions may never be packaged with the original versions
//	- Modified versions may never have the same class names the original versions
//	- Original packages may not be modified in any way
//
//	Model\Skinning\Importing by Willem-Matthijs Crielaard
//	config.cpp by Willem-Matthijs Crielaard and Walker
//	Inspired by Walker's wetsuit addon


#define COC_DIVER_WOUNDS wounds[] = { "xicht_a.paa","xicht_a_zranen", "xicht_b.paa","xicht_a_zranen", "xicht_c.paa","xicht_a_zranen", "xicht_d.paa","xicht_a_zranen",	"xicht_e.paa","xicht_e_zranen", "xicht_f.paa","xicht_a_zranen",	"xicht_g.paa","xicht_a_zranen", "xicht_h.paa","xicht_a_zranen", "xicht_i.paa","xicht_a_zranen",	"xicht_j.paa","xicht_a_zranen", "xicht_k.paa","xicht_a_zranen",	"xicht_l.paa","xicht_a_zranen",	"xicht_m.paa","xicht_a_zranen",	"xicht_n.paa","xicht_a_zranen",	"xicht_o.paa","xicht_o_zranen",	"xicht_p.paa","xicht_a_zranen",	"xicht_q.paa","xicht_a_zranen",	"xicht_r.paa","xicht_a_zranen",	"xicht_s.paa","xicht_a_zranen",	"xicht_t.paa","xicht_a_zranen",	"xicht_u.paa","xicht_a_zranen",	"xicht_v.paa","xicht_v_zranen",	"xicht_w.paa","xicht_w_zranen",	"xicht_x.paa","xicht_a_zranen",	"xicht_y.paa","xicht_a_zranen",	"xicht_z.paa","xicht_a_zranen",	"xicht_2a.paa","xicht_a_zranen","xicht_2b.paa","xicht_w_zranen","xicht_2c.paa","xicht_a_zranen","xicht_2d.paa","xicht_v_zranen","xicht_2e.paa","xicht_a_zranen","xicht_2f.paa","xicht_a_zranen","xicht_2g.paa","xicht_w_zranen","xicht_2h.paa","xicht_a_zranen","xicht_2i.paa","xicht_a_zranen","xicht_2j.paa","xicht_a_zranen","xicht_2k.paa","xicht_a_zranen","xicht_2l.paa","xicht_a_zranen","xicht_2m.paa","xicht_a_zranen","xicht_2n.paa","xicht_a_zranen","xicht_2o.paa","xicht_a_zranen","xicht_2p.paa","xicht_2p_zranen","xicht_2q.paa","xicht_a_zranen","xicht_2r.paa","xicht_e_zranen","xicht_2s.paa","xicht_a_zranen","xicht_2t.paa","xicht_a_zranen","xicht_2u.paa","xicht_a_zranen","xicht_2v.paa","xicht_a_zranen","xicht_2w.paa","xicht_w_zranen","xicht_2x.paa","xicht_a_zranen","xicht_2y.paa","xicht_a_zranen","xicht_2z.paa","xicht_a_zranen","\coc_diver\camoface.paa","\coc_diver\camoface_d.paa","\coc_diver\arm_side_l.paa","\coc_diver\arm_side_l_d.paa","\coc_diver\arm_side_r.paa","\coc_diver\arm_side_r_d.paa","\coc_diver\body_back.paa","\coc_diver\body_back_d.paa","\coc_diver\body_front.paa","\coc_diver\body_front_d.paa","\coc_diver\body_top.paa","\coc_diver\body_top_d.paa","\coc_diver\leg_side_l.paa","\coc_diver\leg_side_l_d.paa","\coc_diver\leg_side_r.paa","\coc_diver\leg_side_r_d.paa","\coc_diver\protec.paa","\coc_diver\protec_d.paa"};

#define TEast 0
#define TWest 1
#define TGuerrila 2
#define TCivilian 3
#define TSideUnknown 4
#define TEnemy 5
#define TFriendly 6
#define TLogic 7

#define true 1
#define false 0

// type scope
#define private 0
#define protected 1
#define public 2

#define WeaponNoSlot		0	// dummy weapons
#define WeaponSlotPrimary	1	// primary weapons
#define WeaponSlotSecondary	16	// secondary weapons
#define WeaponSlotHandGun	2	// HandGun
#define WeaponSlotHandGunItem	32 // HandGun magazines
#define WeaponSlotItem		256	// items
#define WeaponSlotBinocular	4096	// binocular
#define WeaponHardMounted	65536

#define CanSeeRadar 1
#define CanSeeEye 2
#define CanSeeOptics 4
#define CanSeeEar 8
#define CanSeeCompass 16 
#define CanSeeRadarC CanSeeRadar+CanSeeCompass
#define CanSeeAll 31



class CfgPatches
{
	class coc_diver
	{
		Units[] = {	"CoC_Diver", "CoC_DiverSaboteur", "CoC_DiverM16",
				"CoC_DiverSNP", "CoC_DiverM203","CoC_DiverRecon", "CoC_DiverMedic" };
		Vehicles[] = {"CoC_LAR7SWM"};
		weapons[] = {"CoC_LAR7","CoC_DiverPut"};
		requiredVersion = 1.85;		
	};
};

class CfgModels
{
	class Default {};
	class Man: Default {};
	class CoC_Diver: Man {
		sections[] = {	"head injury",
				"body injury",
				"l arm injury",
				"r arm injury",
				"p arm injury",
				"l leg injury",
				"r leg injury",
				"p leg injury",
				"hlava",
				"krk",
				"zasleh",
		};
		sectionsInherit=Head;
	};
	class Weapon: Default {};
	class CoC_LAR7: Weapon {};
	class CoC_LAR7SWM: Weapon {};
};

class CfgFaces
{
	class CoC_DiverCamo
	{
		name = "Camouflaged";
		texture = "\coc_diver\camoface.paa";
		east = false;
		west = false;
	};
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// WEAPONS & AMMO
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CfgAmmo
{
	class default {};
	class coclar7: default
	{
		hit=0.001;
		indirectHit=0.001;
		indirectHitRange=0.01;
		minRange=0.1;
		minRangeProbab=0.100000;
		midRange=1;
		midRangeProbab=0.100000;
		maxRange=2;
		maxRangeProbab=0.10000;
	};
};

class CfgWeapons
{
	class Default{};	
	class LAWLauncher: Default{};
	
	class CoC_LAR7: LAWLauncher
	{
		scopeWeapon = public;
		scopeMagazine = public;
		nameSound="weapon"
		model="\coc_diver\coc_lar7";
		modelOptics="";
		picture="\coc_diver\coc_lar7inv.paa"
		//sound[]={"\coc_diver\breathe.wav",20,1};
		sound[]={"",20,1};
		reloadSound[]={"\coc_diver\breathe.wav",20,1};
		drySound[]={"\coc_diver\breathe",20,1};
		weaponType = WeaponSlotSecondary;
		magazineType = WeaponNoSlot;
		ammo="coclar7";
		displayName = "LAR VII rebreather";
		displayNameMagazine="LAR VII oxygen tank";
		shortNameMagazine="o2 tank";
		reloadTime=1.0;
		canLock=0;
		valueWeapon=20;
		optics = 0;
		forceOptics = 0;
		count=100;
		primary = false;
		uiPicture="\coc_diver\CoC_LAR7.paa";
		canDrop = true;
	};
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// UNITS
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CfgVehicles
{
	class All{};
	class AllVehicles:All{};
	class Land:AllVehicles{};
	class LandVehicle : Land {};

	class Man:Land{};
	class Soldier:Man{};
	class SoldierWB:Soldier{};
	class SoldierWSaboteur: SoldierWB{};
	class SoldierWSaboteurPipe: SoldierWSaboteur{};

	class Car: LandVehicle {};	

	class Tank : LandVehicle {};
	class APC : Tank {};
	class M113 : APC {};


	class CoC_Diver: SoldierWSaboteurPipe
	{
		//uiPicture="\coc_diver\CoC_idiver.paa";
		picture="\coc_diver\CoC_insignia.paa"
		model="\CoC_Diver\CoC_Diver.p3d";
		displayName="Combat swimmer";
		moves="CfgMovesMC";
		vehicleClass ="CoC (Men)";
		scope=2;
		side=TWest;
		sensitivity=1.7;		//org ???
		//accuracy=2.500000;		//3.5
		//camouflage=0.700000;		//0.7
		//nightVision=1;
		hiddenSelections[] = {};
		weapons[]={"M16","Glock","CoC_LAR7","Binocular","Throw","Put"};
		magazines[] = {	"M16", "M16", "M16", "M16",
				"SmokeShellRed", "SmokeShellRed",
				"SmokeShellGreen", "SmokeShellGreen",
				"Handgrenade", "Handgrenade",
				"GlockMag", "GlockMag", "GlockMag", "GlockMag",
				};

		COC_DIVER_WOUNDS

		class Animations
		{
			class goggles
			{
				type="rotation";
				animPeriod=0.5;
				selection="divemask";
				axis="divemask_axis";
				angle0=0.00;
				angle1=0.380;
			};
			class FacecamoState {
				type="rotation";
				animperiod=.01;
				selection="brain";
				axis="brain";
				angle0=0;
				angle1=1.746;
			};
		};
		class UserActions
		{
			class Lowervisor
			{
				displayName="Put dive mask on";
				position="Brain";
				radius=1.00000;
				condition="this animationPhase ""goggles"" < 0.5";
				statement="this animate [""goggles"", 1]";
			};
			class Raisevisor
			{
				displayName="Take dive mask off";
				position="Brain";
				radius=1.00000;
				condition="this animationPhase ""goggles"" >= 0.5";
				statement="this animate [""goggles"", 0]";
			};
//			class CamoFace {
//				displayName="Camouflage face";
//				position="Brain";
//				radius=1;
//				sound={};
//				condition="this animationPhase ""FacecamoState"" == 0";
//				statement="this animate [""FacecamoState"", 1]; this setface ""COC_DiverCamo"";";
//			};
		};
		class EventHandlers {
			Init="_this select 0 exec ""\CoC_Diver\scripts\unit_swimscript.sqs"";";
		};

	};


	class CoC_DiverSaboteur : CoC_Diver
	{
		displayName="Combat swimmer (Demolition)";
		weapons[]={"M16","Glock","CoC_LAR7","Throw","Put"};
		magazines[] = {	"M16", "M16", "M16", "M16",
				"GlockMag", "GlockMag", "GlockMag", "GlockMag",
				"Mine","PipeBomb",
				"HandGrenade","HandGrenade"
				};
	};

	class CoC_DiverM16 : CoC_Diver
	{
		displayName="Combat swimmer (Rifleman)";
		weapons[]={"M16","Glock","CoC_LAR7","Throw","Put"};
		magazines[] = {	"M16", "M16", "M16", "M16",
				"M16", "M16", "M16", "M16",
				"Handgrenade", "Handgrenade",
				"GlockMag", "GlockMag", "GlockMag", "GlockMag",
				};
	};

	class CoC_DiverRecon : CoC_Diver
	{
		displayName="Combat swimmer (Recon)";
		weapons[]={"HK","Glock","CoC_LAR7","Binocular","Throw","Put"};
		magazines[] = {	"HK","HK","HK","HK",
				"SmokeShellRed", "SmokeShellRed",
				"SmokeShellGreen", "SmokeShellGreen",
				"Handgrenade", "Handgrenade",
				"GlockMag", "GlockMag", "GlockMag", "GlockMag",
				};
	};

	class CoC_DiverSNP : CoC_Diver
	{
		displayName="Combat swimmer (Sniper)";
		weapons[]={"M21","Glock","CoC_LAR7","Throw","Put"};
		magazines[] = {	"M21", "M21", "M21", "M21",
				"SmokeShellRed", "SmokeShellRed",
				"SmokeShellGreen", "SmokeShellGreen",
				"Handgrenade", "Handgrenade",
				"GlockMag", "GlockMag", "GlockMag", "GlockMag",
				};
	};

	class CoC_DiverM203 : CoC_Diver
	{
		displayName="Combat swimmer (Grenadier)";
		weapons[]={"M16GrenadeLauncher","Glock","CoC_LAR7","Throw","Put"};
		magazines[] = {	"M16", "M16", "M16", "M16",
				"GrenadeLauncher", "GrenadeLauncher", "GrenadeLauncher",
				"GlockMag", "GlockMag", "GlockMag", "GlockMag",
				};
	};

	class CoC_DiverMedic : CoC_Diver
	{
		displayName = "Combat swimmer (Medic)";
		Attendant   = true;
		picture="\coc_diver\CoC_insignia_medic.paa"
		weapons[]   = {"M16","Glock","CoC_LAR7","Throw","Put"};
		magazines[] = {	"M16", "M16", "M16", "M16",
				"GlockMag", "GlockMag"
				};

		weaponSlots = WeaponSlotPrimary + WeaponSlotSecondary + 4 * WeaponSlotItem + WeaponSlotBinocular + WeaponSlotHandGun + 2*WeaponSlotHandGunItem;
	};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// VEHICLES
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	class CoC_LAR7SWM: Car {


		//////////////////////////
		////// GENERIC INFO //////
		//////////////////////////

		//driverCanSee = 0;
		driverCanSee = CanSeeEar+CanSeeEye;

		reversed=1; // all vehicles are reversed - except static

		vehicleClass="CoC (Swimming gear)";
		displayName="Combat swimmer (in water)";

		type=0;	//0=soft target, 1=armored,2=air

		side=1;
		cost=100000;
		fuelCapacity=200;
		canFloat=1;

		crew="CoC_Diver";
		hasGunner=0;
		hasCommander=0;
		driverIsCommander=0;
		transportSoldier=0;

		simulation="car";
		nameSound="ship";
		// simulation="tank";
		// unitInfoType="UnitInfoAirplane";
		hideUnitInfo=1;
	
		getInRadius=0;
		getInAction="ManActCoC_LAR7_DiverGetIn";
		getOutAction="ManActCoC_LAR7_DiverGetIn";
		driverAction="ManActCoC_LAR7_DiverStill";

		unloadInCombat = 0;
		preferRoads = 0;

		threat[]={0.200000,0.200000,0.100000};	//Needs to be changed


		//////////////////////////
		////    VISIBILITY    ////
		//////////////////////////

		irTarget=false;
		
		accuracy=0; // accuracy needed to recognize type of this target, blackop: 3.5

		camouflage=0;			//Bigger = better spotable, BETA2: 0.1, blackop: 0.7
		audible=0.05;			//Bigger = better heard, BETA2: 0.001, Man:0.05 

		spotableNightLightsOff=0.05;	// night spotability coeficients
		spotableNightLightsOn=0.05;
		visibleNightLightsOff=0.1;	// night target recognition 
		visibleNightLightsOn=0.1;

		//camouflage=0.001;			//Needs to be refined
		//audible=0.001;				//Needs to be refined


		//////////////////////////
		//// SOUND & GRAPHICS ////
		//////////////////////////

		picture="\coc_diver\CoC_LAR7.paa";
		icon="\coc_diver\CoC_iscooba.paa";				//needs own icon (is this for map or section command line)
		model="\coc_diver\coc_lar7SWM.p3d";

		//soundEngine[]={"\coc_diver\swim.ogg",1,1};
		soundEngine[]={"",1,1};
		//sound[]={"\coc_diver\swim.ogg",1,1};
		sound[]={"",1,1};
		soundContinuous=0;
		soundGear[]={};
		soundServo[]={,1,1};

		soundGetOut[]={"\coc_diver\largetout.ogg", db+8, 1.0};
		soundGetIn[]={"\coc_diver\largetin.ogg",db+8, 1.0};

		soundCrash[]={,1,1};
		soundLandCrash[]={};
		soundWaterCrash[]={};
		soundDammage[]={,1,1};

		//insideSoundCoef=0.050000;
		insideSoundCoef=1.000000;

		scope=2;
		optics=1;
		//driverOpticsModel="optika_night";
		//driverOpticsColor[]={0,0,0,1};
		nightVision=0;

		extCameraPosition[]={0,0.3,-3.5};

		minGunElev=-60;maxGunElev=+60; // + up
		minGunTurn=-5;maxGunTurn=+5; // + left - player
		//minGunTurn=-30;maxGunTurn=+30; // + left - player
		minGunTurnAI=-30;maxGunTurnAI=+30; // + left - AI

		fov=0.85; minFov=0.42; maxFov=0.85;
		class ViewPilot
		{
			initAngleX=8; minAngleX=-40; maxAngleX=+45;
			initAngleY=0; minAngleY=-125; maxAngleY=+125;
			initFov=0.7; minFov=0.42; maxFov=0.85;
		};

		

		//////////////////////////
		//////// MOVEMENT ////////
		//////////////////////////

		maxSpeed=12;

		wheelCircumference=1.000000;//IIWDFI
		turnCoef=1.000000;
		terrainCoef=100.00000;//Major problem area --> smaller=faster on land

		steerAheadSimul=0.200000;
		steerAheadPlan=0.200000;
		predictTurnSimul=0.100000;
		predictTurnPlan=0.100000;

		formationX=5;
		formationZ=5;
		precision=1;

		brakeDistance=1;
		formationTime=2;

		//////////////////////////
		//// WEAPONS & ARMOUR  ///
		//////////////////////////

		weapons[]={};
		magazines[]={};
		enableAttack=1;
		armor=1;

		armorGlass=0.000001;
		armorBody=0.000001;
		armorFuel=0.000001;
		armorLights=0.000001;
		armorWheels=0.000001;

		dammageHalf[]={};	//Do this for wounds
		dammageFull[]={};	//Do this for Dead

		armorStructural=0.000001;


		secondaryExplosion=0;
		// value<0: calculate from fuel/ammo cargo + tanks and multiply with abs(value)
		// value>0: use value directly as hit in FuelExplosion


		//////////////////////////
		//// UNKNOWN & UNUSED ////
		//////////////////////////

		class Reflectors 
		{
		};

		class IndicatorAltBaro
		{
			selection="nm_alt";
			axis="osa_nm_alt";
			angle=0;
			min=0;
			max=0;
		};
		class IndicatorSpeed
		{
			selection="ukaz_rychlo";
			axis="osa_rychlo";
			angle=-240;
			min=0;
			max=16.670000;
		};
		class IndicatorSpeed2
		{
			selection="ukaz_rychlo2";
			axis="osa_rychlo2";
			angle=-240;
			min=0;
			max=16.670000;
		};
		class IndicatorRPM
		{
			selection="ukaz_rpm";
			axis="osa_rpm";
			angle=-340;
			min=0;
			max=1;
		};

		class HitEngine
		{
			armor=0.00001;
			material=60;
			name="engine";
			passThrough=1;
		};

		class UserActions
		{
			class StopSwim
			{
				displayName="Stop swimming";
				position="logic";
				radius=1.00000;
				condition="getpos this select 2 > -1.2";
				statement="deletevehicle this";
			};
		}
		class EventHandlers {
			Init="_this select 0 exec ""\CoC_Diver\scripts\vehicle_swimscript.sqs"";";
		};
	};

};

class CfgVehicleActions
{
	CoC_LAR7_DiverStill="CivilLying";
	CoC_LAR7_DiverGetIn="CombatToCrouch";
};



enum {CPDriver,CPGunner,CPCommander,CPCargo};

class CfgNonAIVehicles
{
	class ProxySecWeapon {};
	class ProxyCoC_LAR7 : ProxySecWeapon {};

	class ProxyCrew	{};
	class ProxyDriver: ProxyCrew {crewPosition=CPDriver;};
	class ProxyCoC_LAR7Driver: ProxyDriver {};
}

////////////////////////////////////////////////////////
// GROUPS
////////////////////////////////////////////////////////

class CfgGroups
{
	class West
	{
	name="$STR_WEST";
		class CoC_swimmers
		{
			name="CoC (Combat swimmers)";

			class CoC_SwimTeamDemolition
			{
				name="Demolition Team";
				class Unit0
				{
					side=1;
					vehicle="CoC_Diver";
					rank="Sergeant";
					position[]={0,0,0};
				};
				class Unit1
				{
					side=1;
					vehicle="CoC_DiverSaboteur";
					rank="Corporal";
					position[]={0,-10,0};
				};
				class Unit2
				{
					side=1;
					vehicle="CoC_DiverSaboteur";
					rank="Corporal";
					position[]={10,-10,0};
				};
				class Unit3
				{
					side=1;
					vehicle="CoC_DiverSaboteur";
					rank="Private";
					position[]={-10,-10,0};
				};
				class Unit4
				{
					side=1;
					vehicle="CoC_DiverM16";
					rank="Private";
					position[]={20,-10,0};
				};
				class Unit5
				{
					side=1;
					vehicle="CoC_DiverM203";
					rank="Private";
					position[]={-20,-10,0};
				};
			};
			class CoC_SwimTeamAssault
			{
				name="Light Assault Team";
				class Unit0
				{
					side=1;
					vehicle="CoC_Diver";
					rank="Sergeant";
					position[]={0,0,0};
				};
				class Unit1
				{
					side=1;
					vehicle="CoC_DiverM203";
					rank="Corporal";
					position[]={0,-10,0};
				};
				class Unit2
				{
					side=1;
					vehicle="CoC_DiverM203";
					rank="Corporal";
					position[]={10,-10,0};
				};
				class Unit3
				{
					side=1;
					vehicle="CoC_DiverM16";
					rank="Private";
					position[]={-10,-10,0};
				};
				class Unit4
				{
					side=1;
					vehicle="CoC_DiverM16";
					rank="Private";
					position[]={20,-10,0};
				};
				class Unit5
				{
					side=1;
					vehicle="CoC_DiverMedic";
					rank="Private";
					position[]={-20,-10,0};
				};
			};
			class CoC_SwimTeamRecon
			{
				name="Recon Team";
				class Unit0
				{
					side=1;
					vehicle="CoC_DiverRecon";
					rank="Sergeant";
					position[]={0,0,0};
				};
				class Unit1
				{
					side=1;
					vehicle="CoC_DiverRecon";
					rank="Corporal";
					position[]={0,-10,0};
				};
				class Unit2
				{
					side=1;
					vehicle="CoC_DiverSNP";
					rank="Corporal";
					position[]={10,-10,0};
				};
				class Unit3
				{
					side=1;
					vehicle="CoC_DiverRecon";
					rank="Private";
					position[]={-10,-10,0};
				};
				class Unit4
				{
					side=1;
					vehicle="CoC_DiverRecon";
					rank="Private";
					position[]={20,-10,0};
				};
				class Unit5
				{
					side=1;
					vehicle="CoC_DiverRecon";
					rank="Private";
					position[]={-20,-10,0};
				};

			};
		};
	};
};